TYPO3 Core - Bug #91559

Reverting auto slug update for editors does not work
2020-06-03 09:31 - Chris Miller

Status: Closed Start date: 2020-06-03
Priority: Must have Due date:
Target version:
PHP Version: Is Regression:

Tags: Sprint Focus:

Description

When reverting a redirect which was created as an editor, a successful notification is shown. However, the redirect record is still

available.

As an admin user the redirect record is removed.

This behaviour was observed in TYPO3 10.4.3.

Related issues:

Has duplicate TYPO3 Core - Bug #94105: Redirects not revertable by non admins

Closed 2021-05-10

Associated revisions

Revision d9e04992 - 2021-08-10 12:56 - Albrecht Kohnlein
[BUGFIX] Respect 'ignoreRootLevelRestriction' setting

Respect 'ignoreRootLevelRestriction' TCA setting when fetching history

records. This is required for

generated redirects. Otherwise the page access check always would fail,

non-admins to be able to revert auto

because the redirects are created on page id 0 where a non-admin user

never has access to.

Resolves: #91559
Releases: master, 10.4

Change-ld: 14fa2432b1a9d613766e956ae773380acf7b63f67

Reviewed-on: https://review.

.org/c/Pack /TYPO3.CMS/+/

Tested-by: core-ci <typo3@b13.com>

Tested-by: Henrik Elsner <helsner@dfau.de>

Tested-by: Josef Glatz <j

fglatz@gmail.com>

Tested-by: Georg Ringer <georg.ringer@gmail.com>

Reviewed-by: Henrik Elsner <helsner@dfau.de>
Reviewed-by: Xavier Perseguers <xavier .or

Reviewed-by: Josef Glatz <josefglatz@gmail.com>
Reviewed-by: Georg Ringer <georg.ringer@gmail.com>

Revision 0e36b9e0 - 2021-08-11 06:54 - Albrecht Kéhnlein
[BUGFIX] Respect 'ignoreRootLevelRestriction' setting

Respect 'ignoreRootLevelRestriction' TCA setting when fetching history

records. This is required for

generated redirects. Otherwise the page access check always would fail,

non-admins to be able to revert auto

because the redirects are created on page id 0 where a non-admin user

never has access to.

Resolves: #91559
Releases: master, 10.4

Change-ld: 14fa2432b1a9d613766e956ae773380acf7b63f67

Reviewed-on: https://review.typo3.org/c/Packages/TYPO3.CMS/+/70412

Tested-by: core-ci <typo3@b13.com>

Tested-by: Georg Ringer <georg.ringer@gmail.com>

Reviewed-by: Georg Ringer
<georg.ringer@gmail.com>
History

#1 - 2021-06-05 12:01 - Guido Schmechel
- Has duplicate Bug #94105: Redirects not revertable by non admins added

#2 - 2021-06-05 15:04 - Riccardo De Contardi
| report here the description of #94105 to keep track of it

Non-admin users are not able to revert the redirect via the blue popup on page save, when the slug is changed and the page saved.

How to reproduce:

Create a page “test123” and save

Change page title to “test345", update the slug and save.

Redirect for keyword “test123” in Source Path should be visible in Redirect Module.

Click “Revert redirects only” in the blue popup

Redirect for keyword “test123” in Source Path should be gone in Redirect Module.

Repeat with any non-admin editor (make sure to grant access to redirect module, list rights for redirect show/edit, and allow all fields in the
record itself)

The redirect will not be deleted in the last step.

#3 - 2021-06-18 14:06 - Henrik Elsner

- Priority changed from Should have to Must have

We too have this issue. (with 10.4.17)
And i would declare it as must have as this can highly affect SEO etc.

#4 - 2021-06-28 09:50 - Albrecht Kéhnlein

The problem seems to be combination of the facts, that all redirects are stored on pid=0 and that non-admins don't have page access to page id 0

| xdebug'ed the problem and came out here:
https://github.com/TYPOS3/TYPO3.CMS/blob/7aad9f6dea9246a1cc64f1b076e106605db3e04c/typo3/sysext/backend/Classes/History/RecordHistory.p
hp#1 273

if (empty (SGLOBALS['TCA'][Stable]) || !$this->hasTableAccess ($Stable) || !S$this->hasPageAccess ($Stable, $uid)) {
return [];

}
Calling the method $this->hasPageAccess($table,$uid) will return false.

So one (complex) solution could be to not save redirect records on pid=0 but any other page, the editor has access. A simpler solution could be to
always skip the access tests for table "sys_redirect"

#5 - 2021-06-28 11:20 - Gerrit Code Review

- Status changed from New to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https:/review. .org/c/Pack: TYP

#6 - 2021-07-09 17:43 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/c/Packages/TYPO3.CMS/+/69634

#7 - 2021-07-15 12:27 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/c/Packages/TYPO3.CMS/+/69634

#8 - 2021-08-10 12:56 - Gerrit Code Review

Patch set 1 for branch 10.4 of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review. .org/c/Pack TYPO3.CMS/+/70412

#9 - 2021-08-10 13:00 - Albrecht Kéhnlein
- Status changed from Under Review to Resolved

- % Done changed from 0 to 100
Applied in changeset d9e0499244b218c9c3d2d02280f316722a6da5f4.

#10 - 2021-08-19 10:12 - Alexander Rotzsch
- % Done changed from 100 to 90

Testet it with 10.4.20. Patch is applied correctly and all caches were deleted but taking back redirects for non-admins don't work -> redirects are
stored.

#11 - 2021-09-07 07:40 - Benni Mack

- Status changed from Resolved to Closed

#12 - 2021-09-07 16:05 - Dave Zen

Important: The editor needs modify/write access for the table sys_redirect. This can be changed in the backend user access rights list. Otherwise
reverting the redirect won't work.

#13 - 2021-09-08 06:37 - Alexander Rotzsch

That solved the problem, thanks!

#14 - 2021-09-24 07:50 - Claus Harup

IMO this bug should not be closed; "The editor needs modify/write access for the table sys_redirect” - if these are NOT set why is non admin users
able to create them?

Anyhow the messinging is VERY confusing when modify/write is NOT set, because the non admin editor can NOT revert those redirects :-(
